  subroutine psm_init ()
    include 'psmstate.com'
    gutter(1)=1.0d0
    gutter(2)=1.0d0
  end subroutine psm_init

  integer function sm_device (str)
    include 'psmstate.com'
    character(len=*) str
    integer i,p_level,altstrm,status
    p_level = 0
    sm_device = 0
    i = index(str, ' ')
    if (i.eq.0) then
       i = len(str) + 1
    end if
    if (str(:i-1).eq.'x11') then
       call plsstrm (0)
       call plglevel (p_level)
       if (p_level.eq.0) then
          call plsdev ('xwin')
          call plinit ()
       endif
    else
       call plmkstrm (altstrm)
       call plglevel (p_level)
       if (p_level.eq.0) then
          call psm_dev (str(:i-1),status)
          sm_device = status
          call plsfnam (str(i+1:))
          call plinit ()
       endif
    endif
    call sm_location (3500,31000,3500,31000)
    call sm_window (1,1,1,1,1,1)
    call sm_limits (0.0,1.0,0.0,1.0)
    call psm_init ()
  end function sm_device

  subroutine psm_dev (str,status)
    include 'psmstate.com'
    character(len=*) str
    integer status
    status = 0
    if (str.eq.'postscript') then
       call plsetopt ('ori', '1')
       call plsdev ('ps')
    else if (str.eq.'postport') then
       call plsetopt ('ori', '1')
       call plsdev ('ps')
    else if (str.eq.'postland') then
       call plsetopt ('ori', '2')
       call plsdev ('ps')
    else if (str.eq.'post_colour') then
       call plsdev ('psc')
    else if (str.eq.'blackpostscript') then
       call plsetopt ('ori', '1')
       call plsdev ('ps')
    else if (str.eq.'postfile') then
       call plsetopt ('ori', '1')
       call plsdev ('ps')
    else if (str.eq.'postencap') then
       call plsdev ('ps')
    else if (str.eq.'postlandfile') then
       call plsetopt ('ori', '2')
       call plsdev ('ps')
    else if (str.eq.'post_remote') then
       call plsdev ('ps')
    else if (str.eq.'postscript_remote') then
       call plsdev ('ps')
    else if (str.eq.'postland_remote') then
       call plsdev ('ps')
    else if (str.eq.'postport_remote') then
       call plsdev ('ps')
    else
       status = -1
    end if
  end subroutine psm_dev

  subroutine sm_location (x1,x2,y1,y2)
    include 'psmstate.com'
    integer x1,x2,y1,y2
    location(1)=x1
    location(2)=x2
    location(3)=y1
    location(4)=y2
  end subroutine sm_location

  subroutine sm_window (nx,ny,x,y,x2,y2)
    include 'psmstate.com'
    integer nx,ny,x,y,x2,y2
    window(1)=nx
    window(2)=ny
    window(3)=x
    window(4)=y
    window(5)=x2
    window(6)=y2
    call plssub (window(1),window(2))
    page = (window(2)-window(4))*window(1)+window(3)
    call pladv (page)
  end subroutine sm_window

  subroutine sm_limits (x1,x2,y1,y2)
    include 'psmstate.com'
    real x1,x2,y1,y2
    limits(1)=dble(x1)
    limits(2)=dble(x2)
    limits(3)=dble(y1)
    limits(4)=dble(y2)
    call psm_plvpor (location(1)/dble(s),location(2)/dble(s),location(3)/dble(s),location(4)/dble(s))
    call plwind (limits(1),limits(2),limits(3),limits(4))
  end subroutine sm_limits

  subroutine sm_box (x1,y1,x2,y2)
    include 'psmstate.com'
    integer x1,y1,x2,y2
    character(20) xopt,yopt
    real(kind=plflt) :: xtick,ytick
    integer nxsub,nysub
    xopt='bcst'
    yopt='bcstv'
    xtick=ticksize(2)
    ytick=ticksize(4)
    nxsub=int(ticksize(2)/ticksize(1))
    nysub=int(ticksize(4)/ticksize(3))
    if ((x1.eq.1).or.(x1.eq.2)) then
       xopt='bcstn'
    endif
    if ((y1.eq.1).or.(y1.eq.2)) then
       yopt='bcstvn'
    endif
    if ((x2.eq.1).or.(x2.eq.2)) then
       xopt='bcstm'
    endif
    if ((y2.eq.1).or.(y2.eq.2)) then
       yopt='bcstvm'
    endif
    call psm_plvpor (location(1)/dble(s),location(2)/dble(s),location(3)/dble(s),location(4)/dble(s))
    call plwind (limits(1),limits(2),limits(3),limits(4))
    call plbox (xopt,xtick,nxsub,yopt,ytick,nysub)
  end subroutine sm_box

  subroutine psm_plvpor (x1,x2,y1,y2)
    include 'psmstate.com'
    real(kind=plflt) :: x1,x2,y1,y2
    real(kind=plflt) :: t(4)
    if (window(1)*window(2).eq.1) then
       call plvpor (x1,x2,y1,y2)
    else
       call plschr (0.0d0,1.0d0)
       call psm_plvsta ()
       call plschr (0.0d0,expand*1.0d0)
    endif
  end subroutine psm_plvpor

  subroutine psm_plvsta ()
    include 'psmstate.com'
    real(kind=plflt) :: x(4),pdef,pht
    call plgspa (x(1),x(2),x(3),x(4))
    call plgchr (pdef,pht)
    call plvpor (0.0d0+8*pht/(x(2)-x(1)),1.0d0-5*pht/(x(2)-x(1)),0.0d0+5*pht/(x(4)-x(3)),1.0d0-5*pht/(x(4)-x(3)))
  end subroutine psm_plvsta

  subroutine sm_erase ()
    include 'psmstate.com'
    integer x1,y1,x2,y2
    call plssub (1,1)
    page = 1
    call pladv (page)
    call plvpor (0.d0,1.d0,0.d0,1.d0)
    call plclear ()
    call plssub (window(1),window(2))
    page = (window(2)-window(4))*window(1)+window(3)
    call pladv (page)
    call plfont (2)
    call psm_plvpor (location(1)/dble(s),location(2)/dble(s),location(3)/dble(s),location(4)/dble(s))
    call plwind (limits(1),limits(2),limits(3),limits(4))
  end subroutine sm_erase

  subroutine sm_lweight (lw)
    include 'psmstate.com'
    real lw
    call plwidth (dble(lw))
  end subroutine sm_lweight

  subroutine sm_expand (factor)
    include 'psmstate.com'
    real factor
    expand=dble(factor)
    call plschr (0.0d0,expand*1.0d0)
  end subroutine sm_expand

  subroutine sm_relocate (x,y)
    include 'psmstate.com'
    real x,y
    relocate(1)=dble(x)
    relocate(2)=dble(y)
  end subroutine sm_relocate

  subroutine sm_label (str)
    include 'psmstate.com'
    character(len=*) str
    real(kind=plflt) :: vpd(4),gpd(4),loc(2)
    real(kind=plflt) :: dy
    call plgvpd (vpd(1),vpd(2),vpd(3),vpd(4))
    gpd(1)=vpd(1)*window(1)-window(3)+1
    gpd(2)=vpd(2)*window(1)-window(3)+1
    gpd(3)=vpd(3)*window(2)-window(4)+1
    gpd(4)=vpd(4)*window(2)-window(4)+1
    loc(1)=(gpd(1)+(gpd(2)-gpd(1))/(limits(2)-limits(1))*(relocate(1)-limits(1)))
    loc(2)=(gpd(3)+(gpd(4)-gpd(3))/(limits(4)-limits(3))*(relocate(2)-limits(3)))
    dy=tan(angle*3.14159d0/180.0d0)
    call plvpor (0.d0,1.d0,0.d0,1.d0)
    call plwind (0.d0,1.d0,0.d0,1.d0)
    call plptex (loc(1),loc(2),1.0d0,dy,0.0d0,str)
    call psm_plvpor (location(1)/dble(s),location(2)/dble(s),location(3)/dble(s),location(4)/dble(s))
    call plwind (limits(1),limits(2),limits(3),limits(4))
  end subroutine sm_label

  subroutine sm_ylabel (str)
    include 'psmstate.com'
    character(len=*) str
    call plmtex ('l',5.0d0,0.5d0,0.5d0,str)
  end subroutine sm_ylabel

  subroutine sm_xlabel (str)
    include 'psmstate.com'
    character(len=*) str
    call plmtex ('b',3.2d0,0.5d0,0.5d0,str)
  end subroutine sm_xlabel

  subroutine sm_ticksize (xs,xb,ys,yb)
    include 'psmstate.com'
    real xs,xb,ys,yb
    ticksize(1)=xs
    ticksize(2)=xb
    ticksize(3)=ys
    ticksize(4)=yb
  end subroutine sm_ticksize

  subroutine sm_defvar (str1,str2)
    include 'psmstate.com'
    character(len=*) str1,str2
    if (str1.eq.'x_gutter') then
       read(str2,*) gutter(1)
    endif
    if (str1.eq.'y_gutter') then
       read(str2,*) gutter(2)
    endif
  end subroutine sm_defvar

  subroutine sm_ltype (lt)
    include 'psmstate.com'
    integer lt
    call pllsty (1)
  end subroutine sm_ltype

  subroutine sm_connect (x,y,n)
    include 'psmstate.com'
    real x(*),y(*)
    real(kind=plflt) :: px(n),py(n)
    integer n
    do i=1,n
       px(i) = dble(x(i))
       py(i) = dble(y(i))
    enddo
    call plline (px,py)
  end subroutine sm_connect

  subroutine sm_points (x,y,n)
    include 'psmstate.com'
    real x(*),y(*)
    real(kind=plflt) :: px(n),py(n)
    integer n
    do i=1,n
       px(i) = dble(x(i))
       py(i) = dble(y(i))
    enddo
    call plcol0 (15)
    call plpoin (px(1:n), py(1:n), 17)
  end subroutine sm_points

  subroutine sm_histogram (x,y,n)
    include 'psmstate.com'
    real x(*),y(*)
    real(kind=plflt) :: px(n),py(n)
    integer n
    do i=1,n
       px(i) = dble(x(i))
       py(i) = dble(y(i))
    enddo
    call plbin (px(1:n),py(1:n),1)
  end subroutine sm_histogram

  subroutine sm_ptype (pp,n)
    include 'psmstate.com'
    real pp
    integer n
  end subroutine sm_ptype

  subroutine sm_draw (x,y)
    include 'psmstate.com'
    real x,y
    real(kind=plflt) :: px(2),py(2)
    px(1) = relocate(1)
    py(1) = relocate(2)
    px(2) = dble(x)
    py(2) = dble(y)
    call plline (px,py)
    relocate(1) = px(2)
    relocate(2) = py(2)
  end subroutine sm_draw

  subroutine sm_ctype (c)
    include 'psmstate.com'
    character(len=*) c
    if (c.eq.'white  ') then
       call plcol0 (15)
    endif
    if (c.eq.'red    ') then
       call plcol0 (1)
    endif
    if (c.eq.'cyan   ') then
       call plcol0 (11)
    endif
    if (c.eq.'yellow ') then
       call plcol0 (2)
    endif
    if (c.eq.'green  ') then
       call plcol0 (3)
    endif
    if (c.eq.'magenta') then
       call plcol0 (13)
    endif
    if (c.eq.'blue   ') then
       call plcol0 (9)
    endif
    if (c.eq.'black  ') then
       call plcol0 (1)
    endif
  end subroutine sm_ctype

  subroutine sm_putlabel (i,str)
    include 'psmstate.com'
    character(len=*) str
    call sm_label (str)
  end subroutine sm_putlabel

  subroutine sm_hardcopy ()
    include 'psmstate.com'
    integer altstrm
    call plend1 ()
  end subroutine sm_hardcopy

  subroutine sm_angle (x)
    include 'psmstate.com'
    real x
    angle = dble(x)
  end subroutine sm_angle

  subroutine sm_grid (gi1,gi2)
    include 'psmstate.com'
    grid(1)=gi1+1
    grid(2)=gi2+1
    call sm_box (0,0,0,0)
  end subroutine sm_grid

! Unfinished sub programs

  subroutine sm_gflush ()
    include 'psmstate.com'
  end subroutine sm_gflush

  subroutine sm_alpha ()
    include 'psmstate.com'
  end subroutine sm_alpha

  subroutine sm_graphics ()
    include 'psmstate.com'
  end subroutine sm_graphics
